VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CLS_Fichier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim aFileSystemObject  As FileSystemObject
Public BoiteOuverture As CommonDialog

'==================================================================================
'   OUVRE UN FICHIER TEXTE EXISTANT
'   EN ECRITURE PAR DEFAUT
'   PARAMETRES :
'       NOM DU FICHIER AVEC SON CHEMIN
'       TEXTSTREAM DANS LEQUEL SERA PLACER LE CONTENU DU FICHIER
'   PARAMETRES OPTIONELS :
'       LECTURESEUL SI TRUE ECRITURE IMPOSIBLE
'       POURAJOUR  SI TRUE SE PLACE A LA FIN
'==================================================================================
Public Function OuvreFichierTexte(ByVal NomFichier As String, ByRef TextStream, _
        Optional ByVal LectureSeul As Boolean, _
        Optional ByVal PourAjout As Boolean) As Boolean
    Dim LeFile As File

    On Error GoTo gestion_erreur


    Set LeFile = aFileSystemObject.GetFile(NomFichier)
    If LectureSeul Then
        Set TextStream = LeFile.OpenAsTextStream(1)
    Else
        If PourAjout Then
            Set TextStream = LeFile.OpenAsTextStream(8)
        Else
            Set TextStream = LeFile.OpenAsTextStream(2)
        End If
    End If

    OuvreFichierTexte = True
    Exit Function

gestion_erreur:
    OuvreFichierTexte = False
    MsgBox Err.Description, vbCritical, "ERREUR n" & CStr(Err.Number)
End Function

'==================================================================================
'   CREER UN FICHIER TEXTE
'==================================================================================
Public Function CreerFichierTexte(ByVal NomFichier As String, ByRef TextStream) As Boolean

    Dim LeFile As File

    On Error GoTo gestion_erreur


    Set TextStream = aFileSystemObject.CreateTextFile(NomFichier)
    CreerFichierTexte = True

    Exit Function

gestion_erreur:
    CreerFichierTexte = False
    MsgBox Err.Description, vbCritical, "ERREUR n" & CStr(Err.Number)
End Function

'==================================================================================
'   FERME LE FICHIER TEXTSTREAM
'==================================================================================
Public Function FermeFichier(ByRef TextStream) As Boolean
    On Error GoTo gestion_erreur

    TextStream.Close
    FermeFichier = True

    Exit Function
gestion_erreur:
    FermeFichier = False
    MsgBox Err.Description, vbCritical, "ERREUR n" & CStr(Err.Number)
End Function


'==================================================================================
'   AFFICHE LA BOITE D OUVERTURE DE FICHIER
'   RENVOIE LE NOM AINSI QUE LE CHEMIN DU FICHIER CHOISI
'   EN CAS D ANNULATION RENVOIE ""
'   PARAMETRES OPTIONELS :
'       LES FILTRES : *.* PAR DEFAUT, A PASSER AINSI : "TXT HTML BAT"
'       LE NOM DU FICHIER SANS LE CHEMIN
'       LE TITRE DE LA BOITE D OUVERTURE
'       NUMERO DE L ERREUR QUI C EST PRODUIT
'==================================================================================
Public Function OuvrirFichierExistant(Optional ByVal TypeFile As String, _
        Optional File As String, _
        Optional InitDir As String, _
        Optional ByVal DialogTitle As String, _
        Optional ErrNumber As Long) As String
    Dim tempo As String
    Dim Extention As String


    On Error GoTo ErrHandler
    BoiteOuverture.Flags = cdlOFNHideReadOnly
    BoiteOuverture.Filter = ""
    If InitDir <> "" Then
        BoiteOuverture.InitDir = InitDir
    End If

    BoiteOuverture.CancelError = True

    If DialogTitle <> "" Then BoiteOuverture.DialogTitle = DialogTitle

    If TypeFile = "" Then
        BoiteOuverture.Filter = "ALL FILES (*.*)|*.*"
    Else
        If InStr(1, TypeFile, " ", vbTextCompare) = 0 Then
            BoiteOuverture.Filter = "Fichiers " + UCase(TypeFile) + "|*." + UCase(TypeFile)
        Else
            tempo = UCase(TypeFile)
            While InStr(1, tempo, " ", vbTextCompare) <> 0
                Extention = Mid(tempo, 1, InStr(1, tempo, " ", vbTextCompare) - 1)
                BoiteOuverture.Filter = BoiteOuverture.Filter & "|" & Extention & " Files " + "|*." + Extention
                tempo = Replace(tempo, Extention + " ", "", , 1)
            Wend
            BoiteOuverture.Filter = BoiteOuverture.Filter & "|" & tempo & " Files" + "|*." + tempo
            BoiteOuverture.Filter = Mid(BoiteOuverture.Filter, 2)
        End If
    End If

    BoiteOuverture.FilterIndex = 1
    BoiteOuverture.ShowOpen
    OuvrirFichierExistant = BoiteOuverture.FileName
    File = BoiteOuverture.FileTitle
    ErrNumber = 0
    Exit Function
ErrHandler:
    OuvrirFichierExistant = ""
    File = ""
    ErrNumber = Err.Number
End Function

'==================================================================================
'   AFFICHE LA BOITE DE SAUVEGARDE D UN FICHIER
'   RENVOIE LE NOM AINSI QUE LE CHEMIN DU FICHIER CIBLE
'   EN CAS D ANNULATION RENVOIE ""
'   PARAMETRES OPTIONELS :
'       LES FILTRES : *.* PAR DEFAUT, A PASSER AINSI : "TXT HTML BAT"
'       LE NOM DU FICHIER SANS LE CHEMIN
'       LE TITRE DE LA BOITE DE SAUVEGARDE
'       NUMERO DE L ERREUR QUI C EST PRODUIT
'==================================================================================
Public Function EnregistrerSous(Optional ByVal TypeFile As String, _
        Optional File As String, _
        Optional InitDir As String, _
        Optional ByVal DialogTitle As String, _
        Optional ErrNumber As Long) As String
    Dim tempo As String
    Dim Extention As String



    On Error GoTo ErrHandler
    BoiteOuverture.Flags = cdlOFNHideReadOnly
    BoiteOuverture.Filter = ""

    BoiteOuverture.CancelError = True

    If InitDir <> "" Then
        BoiteOuverture.InitDir = InitDir
    End If



    If DialogTitle <> "" Then BoiteOuverture.DialogTitle = DialogTitle
    If TypeFile = "" Then
        BoiteOuverture.Filter = "Tous les fichiers (*.*)|*.*"
    Else
        If InStr(1, TypeFile, " ", vbTextCompare) = 0 Then
            BoiteOuverture.Filter = "Fichiers " + UCase(TypeFile) + "|*." + UCase(TypeFile)
        Else
            tempo = UCase(TypeFile)
            While InStr(1, tempo, " ", vbTextCompare) <> 0
                Extention = Mid(tempo, 1, InStr(1, tempo, " ", vbTextCompare) - 1)
                BoiteOuverture.Filter = BoiteOuverture.Filter & "|Fichiers " + Extention + "|*." + Extention
                tempo = Replace(tempo, Extention + " ", "", , 1)
            Wend
            BoiteOuverture.Filter = BoiteOuverture.Filter & "|Fichiers " + tempo + "|*." + tempo
            BoiteOuverture.Filter = Mid(BoiteOuverture.Filter, 2)
        End If
    End If

    BoiteOuverture.FilterIndex = 1
    BoiteOuverture.ShowSave
    EnregistrerSous = BoiteOuverture.FileName
    File = BoiteOuverture.FileTitle
    ErrNumber = 0
    Exit Function
ErrHandler:
    EnregistrerSous = ""
    File = ""
    ErrNumber = Err.Number
End Function

'==================================================================================
'
'==================================================================================
Public Function TypeDuFichier(NomFichier As String) As String
    TypeDuFichier = UCase(Mid(NomFichier, InStr(1, NomFichier, ".") + 1))
End Function

'==================================================================================
'
'==================================================================================
Public Function CheminSeul(CheminETfichier As String, FichierSeul As String)
    CheminSeul = Replace(CheminETfichier, FichierSeul, "")
End Function


'==================================================================================
'
'==================================================================================
Private Sub Class_Initialize()
    Set aFileSystemObject = New FileSystemObject
End Sub

Private Sub Class_Terminate()
    Set aFileSystemObject = Nothing
End Sub
